diff --git a/src/qmplay2/CommonJS.hpp b/src/qmplay2/CommonJS.hpp
index 5cf35103..c4157d4e 100644
--- a/src/qmplay2/CommonJS.hpp
+++ b/src/qmplay2/CommonJS.hpp
@@ -67,10 +67,21 @@ public:
     Q_INVOKABLE void addNameForUrl(const QString &url, const QString &name, const bool removeAfterUse = true);
     Q_INVOKABLE  QString getNameForUrl(const QString &url);
 
+private slots:
+    void onNetworkReplyDestroyed();
+    void onTimerTimeout();
+
 private:
+    struct TimerData {
+        int id;
+        QJSValue callback;
+        bool singleShot;
+    };
+
     mutable QMutex m_networkReplyMutex;
     int m_networkReplyId = 0;
     QHash<int, NetworkReply *> m_networkReplies;
+    QHash<QObject*, int> m_networkReplyToId;
 
     mutable QMutex m_ioControllerMutex;
     int m_ioControllerId = 0;
@@ -79,4 +90,5 @@ private:
     QMutex m_timerMutex;
     int m_timerId = 0;
     QHash<int, QTimer *> m_timers;
+    QHash<QTimer*, TimerData> m_timerData;
 };
diff --git a/src/qmplay2/Decoder.cpp b/src/qmplay2/Decoder.cpp
index 41304505..74f5a957 100644
--- a/src/qmplay2/Decoder.cpp
+++ b/src/qmplay2/Decoder.cpp
@@ -23,17 +23,17 @@
 
 class QMPlay2DummyDecoder : public Decoder
 {
-    QString name() const override
+    QString name() const
     {
         return QString();
     }
 
-    bool open(StreamInfo &) override
+    bool open(StreamInfo &)
     {
         return true;
     }
 
-    int decodeVideo(const Packet &encodedPacket, Frame &decoded, AVPixelFormat &newPixFmt, bool flush, unsigned hurry_up) override
+    int decodeVideo(const Packet &encodedPacket, Frame &decoded, AVPixelFormat &newPixFmt, bool flush, unsigned hurry_up)
     {
         Q_UNUSED(newPixFmt)
         Q_UNUSED(flush)
@@ -47,7 +47,7 @@ class QMPlay2DummyDecoder : public Decoder
         return 0;
     }
 
-    int decodeAudio(const Packet &encodedPacket, QByteArray &decoded, double &ts, quint8 &channels, quint32 &sampleRate, bool flush) override
+    int decodeAudio(const Packet &encodedPacket, QByteArray &decoded, double &ts, quint8 &channels, quint32 &sampleRate, bool flush)
     {
         Q_UNUSED(channels)
         Q_UNUSED(sampleRate)
@@ -57,7 +57,7 @@ class QMPlay2DummyDecoder : public Decoder
         return decoded.size();
     }
 
-    bool isDummyDecoder() const override
+    bool isDummyDecoder() const
     {
         return true;
     }
diff --git a/src/qmplay2/DeintHWPrepareFilter.cpp b/src/qmplay2/DeintHWPrepareFilter.cpp
index 3f2911af..0b99e4ec 100644
--- a/src/qmplay2/DeintHWPrepareFilter.cpp
+++ b/src/qmplay2/DeintHWPrepareFilter.cpp
@@ -39,7 +39,7 @@ bool DeintHWPrepareFilter::filter(QQueue<Frame> &framesQueue)
     addFramesToInternalQueue(framesQueue);
     if (!m_internalQueue.isEmpty())
     {
-        Frame frame = m_internalQueue.constFirst();
+        Frame frame = m_internalQueue.first();
 
         if (!m_deinterlace)
             frame.setNoInterlaced();
diff --git a/src/qmplay2/DeintHWPrepareFilter.hpp b/src/qmplay2/DeintHWPrepareFilter.hpp
index 62beb529..b2d41867 100644
--- a/src/qmplay2/DeintHWPrepareFilter.hpp
+++ b/src/qmplay2/DeintHWPrepareFilter.hpp
@@ -27,9 +27,9 @@ public:
     DeintHWPrepareFilter();
     ~DeintHWPrepareFilter();
 
-    bool filter(QQueue<Frame> &framesQueue) override;
+    bool filter(QQueue<Frame> &framesQueue);
 
-    bool processParams(bool *paramsCorrected) override;
+    bool processParams(bool *paramsCorrected);
 
 private:
     bool m_deinterlace = false;
diff --git a/src/qmplay2/Demuxer.cpp b/src/qmplay2/Demuxer.cpp
index d94b8e39..aeb2d16a 100644
--- a/src/qmplay2/Demuxer.cpp
+++ b/src/qmplay2/Demuxer.cpp
@@ -69,7 +69,7 @@ bool Demuxer::create(const QString &url, IOController<Demuxer> &demuxer, FetchTr
 
 Demuxer::~Demuxer()
 {
-    for (StreamInfo *streamInfo : std::as_const(streams_info))
+    for (StreamInfo *streamInfo : streams_info)
         delete streamInfo;
 }
 
diff --git a/src/qmplay2/DockWidget.cpp b/src/qmplay2/DockWidget.cpp
index 4f06ce24..a3e9bc4e 100644
--- a/src/qmplay2/DockWidget.cpp
+++ b/src/qmplay2/DockWidget.cpp
@@ -23,7 +23,7 @@
 
 class EmptyW final : public QWidget
 {
-    QSize sizeHint() const override
+    QSize sizeHint() const
     {
         return QSize(0, 0);
     }
@@ -37,30 +37,37 @@ DockWidget::DockWidget()
 {
     m_visibilityTimer->setSingleShot(true);
     m_visibilityTimer->setInterval(0);
-    connect(m_visibilityTimer, &QTimer::timeout, this, [this] {
-        if (m_lastVisible != m_visible)
-        {
-            emit dockVisibilityChanged(m_visible);
-            m_lastVisible = m_visible;
-        }
-    });
-
-    connect(this, &QDockWidget::visibilityChanged, this, [this](bool visible) {
-        m_visible = visible;
-        if (!m_visibilityTimer->isActive())
-            m_visibilityTimer->start();
-    });
-
-    connect(this, &QDockWidget::dockLocationChanged, this, [this](Qt::DockWidgetArea area) {
-        Q_UNUSED(area)
-        emit shouldStoreSizes();
-    });
+    connect(m_visibilityTimer, SIGNAL(timeout()), this, SLOT(onVisibilityTimeout()));
+    connect(this, SIGNAL(visibilityChanged(bool)), this, SLOT(onVisibilityChanged(bool)));
+    connect(this, SIGNAL(dockLocationChanged(Qt::DockWidgetArea)), this, SLOT(onDockLocationChanged(Qt::DockWidgetArea)));
 }
 DockWidget::~DockWidget()
 {
     delete m_emptyW;
 }
 
+void DockWidget::onVisibilityTimeout()
+{
+    if (m_lastVisible != m_visible)
+    {
+        emit dockVisibilityChanged(m_visible);
+        m_lastVisible = m_visible;
+    }
+}
+
+void DockWidget::onVisibilityChanged(bool visible)
+{
+    m_visible = visible;
+    if (!m_visibilityTimer->isActive())
+        m_visibilityTimer->start();
+}
+
+void DockWidget::onDockLocationChanged(Qt::DockWidgetArea area)
+{
+    Q_UNUSED(area)
+    emit shouldStoreSizes();
+}
+
 void DockWidget::setTitleBarVisible(bool v)
 {
     m_titleBarVisible = v;
diff --git a/src/qmplay2/DockWidget.hpp b/src/qmplay2/DockWidget.hpp
index c3d34d73..ef2180e7 100644
--- a/src/qmplay2/DockWidget.hpp
+++ b/src/qmplay2/DockWidget.hpp
@@ -38,14 +38,19 @@ public:
     void setResizingByMainWindow(bool r);
 
 protected:
-    void resizeEvent(QResizeEvent *e) override;
-    void showEvent(QShowEvent *e) override;
-    void closeEvent(QCloseEvent *e) override;
+    void resizeEvent(QResizeEvent *e);
+    void showEvent(QShowEvent *e);
+    void closeEvent(QCloseEvent *e);
 
 signals:
     void dockVisibilityChanged(bool visible);
     void shouldStoreSizes();
 
+private slots:
+    void onVisibilityTimeout();
+    void onVisibilityChanged(bool visible);
+    void onDockLocationChanged(Qt::DockWidgetArea area);
+
 private:
     QWidget *const m_emptyW;
     QTimer *const m_visibilityTimer;
diff --git a/src/qmplay2/Functions.cpp b/src/qmplay2/Functions.cpp
index f6f68b88..d134d405 100644
--- a/src/qmplay2/Functions.cpp
+++ b/src/qmplay2/Functions.cpp
@@ -34,20 +34,19 @@
 #include <QPainter>
 #include <QDir>
 #include <QUrl>
-#include <QWindow>
+// Qt4: No QWindow (use QWidget instead)
+#include <QWidget>
 #include <QLibrary>
 #include <QTextCodec>
 #include <QMessageBox>
 #include <QStyleOption>
 #include <QInputDialog>
-#include <QGuiApplication>
+// Qt4: No QGuiApplication (use QApplication)
+#include <QApplication>
 #include <QVarLengthArray>
-#include <QRegularExpression>
-#if QT_VERSION >= QT_VERSION_CHECK(6, 0, 0)
-# include <QInputDevice>
-#else
-# include <QTouchDevice>
-#endif
+#include <QRegExp>
+// Qt4: No QInputDevice/QTouchDevice in Qt4
+// Touch device APIs are Qt5+
 
 extern "C"
 {
@@ -60,6 +59,7 @@ extern "C"
 
 using namespace std;
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
 static inline QWindow *getNativeWindow(const QWidget *w)
 {
     if (w)
@@ -69,12 +69,13 @@ static inline QWindow *getNativeWindow(const QWidget *w)
     }
     return nullptr;
 }
+#endif
 
 /**/
 
 QDate Functions::parseVersion(const QString &dateTxt)
 {
-    const QStringList l = dateTxt.split(QRegularExpression(R"(\D)"));
+    const QStringList l = dateTxt.split(QRegExp("\\D"));
     int y = 0, m = 0, d = 0;
     if (l.count() >= 3)
     {
@@ -146,7 +147,8 @@ QString Functions::Url(QString url, const QString &pth)
             url.prepend(addPth);
         }
 #ifndef Q_OS_WIN
-        if (hasBackslash && !QFileInfo::exists(url))
+        // Qt4: QFileInfo::exists() is not a static method
+        if (hasBackslash && !QFileInfo(url).exists())
             url.replace("\\", "/");
 #endif
         url.prepend("file://");
@@ -196,7 +198,7 @@ QString Functions::fileName(QString f, bool extension)
         if (real_url.startsWith("file://"))
             return fileName(real_url, extension);
         if (!extension && isResourcePlaylist(f))
-            return fileName(QStringLiteral("QMPlay2://") + real_url, false);
+            return fileName(QString("QMPlay2://") + real_url, false);
         return real_url;
     }
     /**/
@@ -318,10 +320,16 @@ QPixmap Functions::getPixmapFromIcon(const QIcon &icon, QSize size, QWidget *w)
     else
     {
         imgSize = icon.availableSizes().value(0);
+        // Qt4: QSize::scale() returns void, not QSize
         imgSize.scale(size, size.isEmpty() ? Qt::KeepAspectRatioByExpanding : Qt::KeepAspectRatio);
     }
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     return icon.pixmap(getNativeWindow(w), imgSize);
+#else
+    // Qt4: icon.pixmap() doesn't take QWindow*, just use size
+    return icon.pixmap(imgSize);
+#endif
 }
 void Functions::drawPixmap(QPainter &p, const QPixmap &pixmap, const QWidget *w, Qt::TransformationMode transformationMode, Qt::AspectRatioMode aRatioMode, QSize size, qreal scale, bool alwaysAllowEnlarge)
 {
@@ -353,7 +361,11 @@ void Functions::drawPixmap(QPainter &p, const QPixmap &pixmap, const QWidget *w,
         if (pixmapSize.height() > pixmap.height())
             pixmapSize.setHeight(pixmap.height());
     }
-    pixmapSize = pixmap.size().scaled(pixmapSize, aRatioMode);
+    // Qt4/Qt5: QSize::scaled() returns QSize in Qt5, but is void in Qt4
+    // Create a copy and scale it
+    QSize originalSize = pixmap.size();
+    originalSize.scale(pixmapSize, aRatioMode);
+    pixmapSize = originalSize;
 
     const bool isSmooth = (transformationMode == Qt::SmoothTransformation);
     const QPoint pixmapPos {
@@ -362,9 +374,14 @@ void Functions::drawPixmap(QPainter &p, const QPixmap &pixmap, const QWidget *w,
     };
     if (isSmooth && (pixmapSize.width() < pixmap.width() / 2 || pixmapSize.height() < pixmap.height() / 2))
     {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         const qreal dpr = w->devicePixelRatioF();
         pixmapToDraw = pixmapToDraw.scaled(pixmapSize * dpr, Qt::IgnoreAspectRatio, Qt::SmoothTransformation);
         pixmapToDraw.setDevicePixelRatio(dpr);
+#else
+        // Qt4: No HiDPI support, just scale normally
+        pixmapToDraw = pixmapToDraw.scaled(pixmapSize, Qt::IgnoreAspectRatio, Qt::SmoothTransformation);
+#endif
         p.drawPixmap(pixmapPos, pixmapToDraw);
     }
     else
@@ -426,7 +443,12 @@ void Functions::paintOSD(bool rgbSwapped, const QMPlay2OSDList &osd_list, const
                 (const uchar *)img.rgba.constData(),
                 img.size.width(),
                 img.size.height(),
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
                 rgbSwapped ? QImage::Format_RGBA8888 : QImage::Format_ARGB32
+#else
+                // Qt4: Use Format_ARGB32 or Format_RGB888 (no RGBA8888)
+                rgbSwapped ? QImage::Format_RGB888 : QImage::Format_ARGB32
+#endif
             );
             if (osd->needsRescale())
             {
@@ -595,25 +617,22 @@ QByteArray Functions::convertToASS(QString txt)
     txt.replace('\n', "\\N", Qt::CaseInsensitive);
 
     // Colors
-    const QRegularExpression colorRegExp(
-        R"(<font\s+color\s*=\s*\"?\#?(\w{6})\"?\s*>(.*)<\/font\s*>)",
-        QRegularExpression::CaseInsensitiveOption | QRegularExpression::InvertedGreedinessOption
-    );
+    // Qt4: Use QRegExp instead of QRegularExpression
+    QRegExp colorRegExp("<font\\s+color\\s*=\\s*\"?\\#?(\\w{6})\"?\\s*>(.*)</font\\s*>", Qt::CaseInsensitive);
+    colorRegExp.setMinimal(true);
     int pos = 0;
     for (;;)
     {
-        const auto match = colorRegExp.match(txt, pos);
-        if (!match.hasMatch())
+        pos = colorRegExp.indexIn(txt, pos);
+        if (pos == -1)
             break;
 
-        pos = match.capturedStart();
-
-        QString rgb = match.captured(1);
+        QString rgb = colorRegExp.cap(1);
         rgb = rgb.mid(4, 2) + rgb.mid(2, 2) + rgb.mid(0, 2);
 
-        const QString replaced = "{\\1c&" + rgb + "&}" + match.captured(2) + "{\\1c}";
+        const QString replaced = "{\\1c&" + rgb + "&}" + colorRegExp.cap(2) + "{\\1c}";
 
-        txt.replace(pos, match.capturedLength(), replaced);
+        txt.replace(pos, colorRegExp.matchedLength(), replaced);
         pos += replaced.length();
     }
 
@@ -641,7 +660,7 @@ QStringList Functions::getUrlsFromMimeData(const QMimeData *mimeData, const bool
     }
     else if (mimeData->hasText())
     {
-        urls = mimeData->text().remove('\r').split('\n', Qt::SkipEmptyParts);
+        urls = mimeData->text().remove('\r').split('\n', QString::SkipEmptyParts);
     }
     if (checkExtensionsForUrl)
     {
@@ -727,7 +746,7 @@ bool Functions::isResourcePlaylist(const QString &url)
     QString realUrl, addressPrefixName;
     if (!Functions::splitPrefixAndUrlIfHasPluginPrefix(url, &addressPrefixName, &realUrl))
         return false;
-    return (addressPrefixName == QStringLiteral("QMPlay2")) && realUrl.endsWith(".pls");
+    return (addressPrefixName == QString("QMPlay2")) && realUrl.endsWith(".pls");
 }
 
 void Functions::hFlip(quint8 *data, int linesize, int height, int width)
@@ -799,11 +818,15 @@ quint32 Functions::getBestSampleRate()
 
 bool Functions::wrapMouse(QWidget *widget, QPoint &mousePos, int margin)
 {
+    // Qt4 compatibility: Use platform macros instead of QGuiApplication::platformName()
+    // Mouse wrapping is primarily for Windows and X11, not macOS
     static bool allowed =
-            QGuiApplication::platformName() == QStringLiteral("windows")
-         || QGuiApplication::platformName() == QStringLiteral("xcb")
-#if QT_VERSION >= QT_VERSION_CHECK(6, 10, 0)
-         || QGuiApplication::platformName().contains(QStringLiteral("wayland"))
+#if defined(Q_OS_WIN)
+            true
+#elif defined(Q_OS_LINUX) || defined(Q_OS_UNIX)
+            true  // X11/Wayland on Linux
+#else
+            false // macOS and other platforms
 #endif
     ;
     if (!allowed)
@@ -987,30 +1010,32 @@ QMatrix4x4 Functions::getColorPrimariesToSpecifiedMatrix(const QVector2D &wp, ar
 
     auto getRgbToXyzMatrix = [](const QVector2D &wp, const QVector2D &r, const QVector2D &g, const QVector2D &b) {
         auto xyToXyz = [](const QVector2D &v) {
+            // Qt4: Use .x() and .y() instead of subscript operator
             return QVector3D(
-                v[0] / v[1],
+                v.x() / v.y(),
                 1.0f,
-                (1.0f - v[0] - v[1]) / v[1]
+                (1.0f - v.x() - v.y()) / v.y()
             );
         };
 
         const auto wpXyz = xyToXyz(wp);
 
-        const auto ry = r[1];
-        const auto gy = g[1];
-        const auto by = b[1];
+        // Qt4: Use .x() and .y() instead of subscript operator
+        const auto ry = r.y();
+        const auto gy = g.y();
+        const auto by = b.y();
 
-        const auto Xr = r[0] / ry;
+        const auto Xr = r.x() / ry;
         const auto Yr = 1.0f;
-        const auto Zr = (1.0f - r[0] - r[1]) / ry;
+        const auto Zr = (1.0f - r.x() - r.y()) / ry;
 
-        const auto Xg = g[0] / gy;
+        const auto Xg = g.x() / gy;
         const auto Yg = 1.0f;
-        const auto Zg = (1.0f - g[0] - g[1]) / gy;
+        const auto Zg = (1.0f - g.x() - g.y()) / gy;
 
-        const auto Xb = b[0] / by;
+        const auto Xb = b.x() / by;
         const auto Yb = 1.0f;
-        const auto Zb = (1.0f - b[0] - b[1]) / by;
+        const auto Zb = (1.0f - b.x() - b.y()) / by;
 
         const auto S = QMatrix4x4(
             Xr,   Xg,   Xb,   0.0f,
@@ -1019,11 +1044,12 @@ QMatrix4x4 Functions::getColorPrimariesToSpecifiedMatrix(const QVector2D &wp, ar
             0.0f, 0.0f, 0.0f, 1.0f
         ).inverted().map(wpXyz);
 
+        // Qt4: Use .x(), .y(), .z() instead of subscript operator
         return QMatrix4x4(
-            S[0] * Xr, S[1] * Xg, S[2] * Xb, 0.0f,
-            S[0] * Yr, S[1] * Yg, S[2] * Yb, 0.0f,
-            S[0] * Zr, S[1] * Zg, S[2] * Zb, 0.0f,
-            0.0f,      0.0f,      0.0f,      1.0f
+            S.x() * Xr, S.y() * Xg, S.z() * Xb, 0.0f,
+            S.x() * Yr, S.y() * Yg, S.z() * Yb, 0.0f,
+            S.x() * Zr, S.y() * Zg, S.z() * Zb, 0.0f,
+            0.0f,       0.0f,       0.0f,       1.0f
         );
     };
 
@@ -1057,19 +1083,21 @@ QMatrix4x4 Functions::getColorPrimariesToSpecifiedMatrix(AVColorPrimaries colorP
 
 bool Functions::compareText(const QString &a, const QString &b)
 {
-    QRegularExpression rx(R"(\d+)");
+    // Qt4: Use QRegExp instead of QRegularExpression
+    QRegExp rx("\\d+");
 
-    auto fillMatches = [](auto &&matchIt, auto &&matches) {
-        while (matchIt.hasNext())
+    auto fillMatches = [&rx](const QString &text, std::vector<std::pair<int, int>> &matches) {
+        int pos = 0;
+        while ((pos = rx.indexIn(text, pos)) != -1)
         {
-            const auto match = matchIt.next();
-            matches.emplace_back(match.capturedStart(), match.captured().length());
+            matches.emplace_back(pos, rx.matchedLength());
+            pos += rx.matchedLength();
         }
     };
 
     std::vector<std::pair<int, int>> matchesA, matchesB;
-    fillMatches(rx.globalMatch(a), matchesA);
-    fillMatches(rx.globalMatch(b), matchesB);
+    fillMatches(a, matchesA);
+    fillMatches(b, matchesB);
 
     const int n = qMin(matchesA.size(), matchesB.size());
     if (n > 0)
@@ -1116,7 +1144,7 @@ bool Functions::hasTouchScreen()
             return true;
         }
     }
-#else
+#elif QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     const auto touchDevs = QTouchDevice::devices();
     for (auto &&touchDev : touchDevs)
     {
@@ -1125,6 +1153,9 @@ bool Functions::hasTouchScreen()
             return true;
         }
     }
+#else
+    // Qt4: No touch device detection available
+    return false;
 #endif
     return false;
 }
@@ -1145,7 +1176,8 @@ QString Functions::getSeqFile(const QString &dir, const QString &ext, const QStr
     quint16 num = 0;
     for (const QString &f : QDir(dir).entryList({QString("QMPlay2_%1_?????%2").arg(frag, ext)}, QDir::Files, QDir::Name))
     {
-        const quint16 n = QStringView(f).mid(8 + frag.size() + 1, 5).toUShort();
+        // Qt4: No QStringView, use QString::mid() directly
+        const quint16 n = f.mid(8 + frag.size() + 1, 5).toUShort();
         if (n > num)
             num = n;
     }
@@ -1189,6 +1221,31 @@ std::pair<QString, QString> Functions::determineExtFmt(const QList<StreamInfo *>
     return {ext, fmt};
 }
 
+// Qt4 helper for getUserDoubleValue
+namespace {
+class DoubleValueHelper : public QObject
+{
+    Q_OBJECT
+public:
+    DoubleValueHelper(const function<void(double)> &callback, QObject *parent = nullptr)
+        : QObject(parent), m_callback(callback) {}
+
+public slots:
+    void onValueChanged(double newValue)
+    {
+        if (qFuzzyIsNull(newValue))
+            m_callback(0.0);
+        else if (qFuzzyCompare(newValue, 1.0))
+            m_callback(1.0);
+        else
+            m_callback(newValue);
+    }
+
+private:
+    function<void(double)> m_callback;
+};
+}
+
 void Functions::getUserDoubleValue(QWidget *parent, const QString &title, const QString &label, double value, double min, double max, int decimals, double step, const function<void(double)> &onChanged)
 {
     Q_ASSERT(onChanged);
@@ -1198,18 +1255,17 @@ void Functions::getUserDoubleValue(QWidget *parent, const QString &title, const
     input.setWindowTitle(title);
     input.setTextValue(label);
     input.setDoubleDecimals(decimals);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 10, 0)
     input.setDoubleStep(step);
+#else
+    // Qt4: setDoubleStep() doesn't exist, step is handled automatically
+    Q_UNUSED(step)
+#endif
     input.setDoubleRange(min, max);
     input.setDoubleValue(value);
 
-    QObject::connect(&input, &QInputDialog::doubleValueChanged, parent, [&onChanged](double newValue) {
-        if (qFuzzyIsNull(newValue))
-            onChanged(0.0);
-        else if (qFuzzyCompare(newValue, 1.0))
-            onChanged(1.0);
-        else
-            onChanged(newValue);
-    });
+    DoubleValueHelper helper(onChanged, &input);
+    QObject::connect(&input, SIGNAL(doubleValueChanged(double)), &helper, SLOT(onValueChanged(double)));
 
     onChanged(value);
 
@@ -1218,3 +1274,5 @@ void Functions::getUserDoubleValue(QWidget *parent, const QString &title, const
         onChanged(value);
     }
 }
+
+#include "Functions.moc"
diff --git a/src/qmplay2/Functions.hpp b/src/qmplay2/Functions.hpp
index 7ee0962b..c76bf59a 100644
--- a/src/qmplay2/Functions.hpp
+++ b/src/qmplay2/Functions.hpp
@@ -48,7 +48,7 @@ class QRect;
 #ifdef Q_OS_WIN
     #include <windows.h>
 #else
-    #ifdef Q_OS_MACOS
+    #ifdef Q_OS_MAC
         #include <mach/mach_time.h>
     #else
         #include <time.h>
@@ -90,7 +90,7 @@ namespace Functions
         QueryPerformanceFrequency(&Frequency);
         QueryPerformanceCounter(&Counter);
         return (double)Counter.QuadPart / (double)Frequency.QuadPart;
-#elif defined Q_OS_MACOS
+#elif defined Q_OS_MAC
         mach_timebase_info_data_t mach_base_info;
         mach_timebase_info(&mach_base_info);
         return ((double)mach_absolute_time() * (double)mach_base_info.numer) / (1000000000.0 * (double)mach_base_info.denom);
diff --git a/src/qmplay2/GPUInstance.cpp b/src/qmplay2/GPUInstance.cpp
index 9a58f46a..e2575149 100644
--- a/src/qmplay2/GPUInstance.cpp
+++ b/src/qmplay2/GPUInstance.cpp
@@ -21,8 +21,8 @@
 
 #ifdef USE_OPENGL
 #   include <opengl/OpenGLInstance.hpp>
-#   include <QOffscreenSurface>
-#   include <QOpenGLFunctions>
+#   include <QtOpenGL/QGLPixelBuffer>
+#   include <QtOpenGL/QGLContext>
 #endif
 #ifdef USE_VULKAN
 #   include <vulkan/VulkanInstance.hpp>
@@ -45,15 +45,13 @@ shared_ptr<GPUInstance> GPUInstance::create()
 #   ifdef USE_OPENGL
         if (!vkInstance->isPhysicalDeviceGpu() && !sets.getBool("Vulkan/UserApplied"))
         {
-            QOffscreenSurface surface;
-            QOpenGLContext glCtx;
-
-            surface.create();
-            if (!glCtx.create() || !glCtx.makeCurrent(&surface))
+            // Qt4: Use QGLPixelBuffer instead of QOffscreenSurface
+            QGLPixelBuffer pbuffer(1, 1);
+            if (!pbuffer.isValid() || !pbuffer.makeCurrent())
                 return vkInstance;
 
-            const auto currentRenderer = QByteArray(reinterpret_cast<const char *>(glCtx.functions()->glGetString(GL_RENDERER))).toLower();
-            for (auto &&swRendererName : {"llvmpipe", "software", "swrast", "softpipe"})
+            const auto currentRenderer = QByteArray(reinterpret_cast<const char *>(glGetString(GL_RENDERER))).toLower();
+            foreach (const char *swRendererName, {"llvmpipe", "software", "swrast", "softpipe"})
             {
                 if (currentRenderer.contains(swRendererName))
                     return vkInstance;
diff --git a/src/qmplay2/IPC.hpp b/src/qmplay2/IPC.hpp
index 8341e743..f3b0b4c9 100644
--- a/src/qmplay2/IPC.hpp
+++ b/src/qmplay2/IPC.hpp
@@ -31,7 +31,7 @@ class IPCServerPriv;
 
 class QSocketNotifier;
 
-class QMPLAY2SHAREDLIB_EXPORT IPCSocket final : public QIODevice
+class QMPLAY2SHAREDLIB_EXPORT IPCSocket : public QIODevice
 {
     Q_OBJECT
     friend class IPCServer;
@@ -41,8 +41,8 @@ public:
 
     bool isConnected() const;
 
-    bool open(OpenMode mode) override;
-    void close() override;
+    bool open(OpenMode mode);
+    void close();
 
 private slots:
     void socketReadActive();
@@ -54,15 +54,15 @@ private:
     IPCSocket(int socket, QObject *parent);
 #endif
 
-    qint64 readData(char *data, qint64 maxSize) override;
-    qint64 writeData(const char *data, qint64 maxSize) override;
+    qint64 readData(char *data, qint64 maxSize);
+    qint64 writeData(const char *data, qint64 maxSize);
 
     IPCSocketPriv *m_priv;
 };
 
 /**/
 
-class QMPLAY2SHAREDLIB_EXPORT IPCServer final : public QObject
+class QMPLAY2SHAREDLIB_EXPORT IPCServer : public QObject
 {
     Q_OBJECT
 public:
diff --git a/src/qmplay2/IPC_Unix.cpp b/src/qmplay2/IPC_Unix.cpp
index 21f0d80e..a89242d2 100644
--- a/src/qmplay2/IPC_Unix.cpp
+++ b/src/qmplay2/IPC_Unix.cpp
@@ -30,7 +30,7 @@ static sockaddr_un getSockAddr(const QString &fileName)
     sockaddr_un sockAddr;
     sockAddr.sun_family = AF_UNIX;
     strncpy(sockAddr.sun_path, fileName.toLocal8Bit(), sizeof sockAddr.sun_path - 1);
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     sockAddr.sun_len = SUN_LEN(&sockAddr);
 #endif
     return sockAddr;
diff --git a/src/qmplay2/IPC_Windows.cpp b/src/qmplay2/IPC_Windows.cpp
index aa252c2e..b7fc31f5 100644
--- a/src/qmplay2/IPC_Windows.cpp
+++ b/src/qmplay2/IPC_Windows.cpp
@@ -37,7 +37,7 @@ public:
     }
 
 private:
-    void run() override
+    void run()
     {
         WaitForSingleObject(m_event, INFINITE);
     }
diff --git a/src/qmplay2/InDockW.cpp b/src/qmplay2/InDockW.cpp
index eee4850a..d0b576b5 100644
--- a/src/qmplay2/InDockW.cpp
+++ b/src/qmplay2/InDockW.cpp
@@ -43,6 +43,9 @@ InDockW::InDockW(const QColor &grad1, const QColor &grad2, const QColor &qmpTxt)
     setMouseTracking(true);
     updateSettings();
 }
+InDockW::~InDockW()
+{
+}
 
 QWidget *InDockW::getWidget()
 {
diff --git a/src/qmplay2/InDockW.hpp b/src/qmplay2/InDockW.hpp
index b08942e6..225f0d42 100644
--- a/src/qmplay2/InDockW.hpp
+++ b/src/qmplay2/InDockW.hpp
@@ -23,11 +23,12 @@
 #include <QPointer>
 #include <QWidget>
 
-class QMPLAY2SHAREDLIB_EXPORT InDockW final : public QWidget
+class QMPLAY2SHAREDLIB_EXPORT InDockW : public QWidget
 {
     Q_OBJECT
 public:
     InDockW(const QColor &, const QColor &, const QColor &);
+    ~InDockW();
 
     QWidget *getWidget();
     void setLoseHeight(int lh);
@@ -49,11 +50,11 @@ private slots:
 public:
     void setWidget(QWidget *newW);
 protected:
-    void resizeEvent(QResizeEvent *) override;
-    void paintEvent(QPaintEvent *) override;
-    void enterEvent(Q_ENTER_EVENT *) override;
-    void leaveEvent(QEvent *) override;
-    bool event(QEvent *) override;
+    void resizeEvent(QResizeEvent *);
+    void paintEvent(QPaintEvent *);
+    void enterEvent(Q_ENTER_EVENT *);
+    void leaveEvent(QEvent *);
+    bool event(QEvent *);
 signals:
     void resized(const QSize &size);
     void itemDropped(const QString &);
diff --git a/src/qmplay2/LibASS.cpp b/src/qmplay2/LibASS.cpp
index 39090c72..c36d35b8 100644
--- a/src/qmplay2/LibASS.cpp
+++ b/src/qmplay2/LibASS.cpp
@@ -492,9 +492,10 @@ bool LibASS::getASS(shared_ptr<QMPlay2OSD> &osd, double pos)
     if (!ass_sub_track || !ass_sub_renderer || !W || !H)
         return false;
 
-    if (qIsNaN(pos))
+    // Qt4/Qt5: Use std::isnan instead of std::isnan
+    if (std::isnan(pos))
         pos = m_lastPos;
-    if (qIsNaN(pos))
+    if (std::isnan(pos))
         return false;
 
     double _fontScale = fontScale;
@@ -573,7 +574,7 @@ void LibASS::closeASS()
     ass_sub_track = nullptr;
     ass_sub_renderer = nullptr;
     ass_clear_fonts(m_subsAss);
-    m_lastPos = qQNaN();
+    m_lastPos = std::numeric_limits<double>::quiet_NaN();
     m_assIDs.clear();
 }
 
diff --git a/src/qmplay2/LibASS.hpp b/src/qmplay2/LibASS.hpp
index 52ff969a..de970b00 100644
--- a/src/qmplay2/LibASS.hpp
+++ b/src/qmplay2/LibASS.hpp
@@ -18,6 +18,8 @@
 
 #pragma once
 
+#include <limits>
+
 #include <QMPlay2Lib.hpp>
 
 #include <QByteArray>
@@ -72,7 +74,7 @@ public:
     void addASSEvents(const QList<QByteArray> &events, double start, double duration);
     void addASSEvent(const QByteArray &, double, double);
     void flushASSEvents();
-    bool getASS(std::shared_ptr<QMPlay2OSD> &osd, double pos = qQNaN());
+    bool getASS(std::shared_ptr<QMPlay2OSD> &osd, double pos = std::numeric_limits<double>::quiet_NaN());
     void closeASS();
 
 private:
@@ -98,7 +100,7 @@ private:
     ass_renderer *ass_sub_renderer;
     QList<ass_style *> ass_sub_styles_copy;
     bool hasASSData;
-    double m_lastPos = qQNaN();
+    double m_lastPos = std::numeric_limits<double>::quiet_NaN();
     std::set<int> m_assIDs;
 
 #ifdef USE_VULKAN
diff --git a/src/qmplay2/LineEdit.cpp b/src/qmplay2/LineEdit.cpp
index 3691d3a3..06cbaa9d 100644
--- a/src/qmplay2/LineEdit.cpp
+++ b/src/qmplay2/LineEdit.cpp
@@ -25,13 +25,20 @@
 LineEdit::LineEdit(QWidget *parent)
     : QLineEdit(parent)
 {
-    QAction *clearAct = addAction(QMPlay2Core.getIconFromTheme("edit-clear"), TrailingPosition);
-    connect(clearAct, &QAction::triggered, this, &LineEdit::clearText);
-    connect(this, &LineEdit::textChanged, this, [=](const QString &text) {
-        clearAct->setVisible(!text.isEmpty());
-    });
-    clearAct->setToolTip(tr("Clear"));
-    clearAct->setVisible(false);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
+    m_clearAct = addAction(QMPlay2Core.getIconFromTheme("edit-clear"), TrailingPosition);
+#else
+    // Qt4: QLineEdit::addAction() doesn't exist, use a QAction with no position
+    m_clearAct = new QAction(QMPlay2Core.getIconFromTheme("edit-clear"), tr("Clear"), this);
+    // Note: In Qt4, we can't add actions directly to QLineEdit, so this will be less integrated
+#endif
+    connect(m_clearAct, SIGNAL(triggered()), this, SLOT(clearText()));
+    connect(this, SIGNAL(textChanged(QString)), this, SLOT(onTextChanged(QString)));
+    m_clearAct->setToolTip(tr("Clear"));
+    m_clearAct->setVisible(false);
+}
+LineEdit::~LineEdit()
+{
 }
 
 void LineEdit::clearText()
@@ -39,3 +46,8 @@ void LineEdit::clearText()
     clear();
     emit clearButtonClicked();
 }
+
+void LineEdit::onTextChanged(const QString &text)
+{
+    m_clearAct->setVisible(!text.isEmpty());
+}
diff --git a/src/qmplay2/LineEdit.hpp b/src/qmplay2/LineEdit.hpp
index 7c20a4a4..9e28b2f5 100644
--- a/src/qmplay2/LineEdit.hpp
+++ b/src/qmplay2/LineEdit.hpp
@@ -22,15 +22,25 @@
 
 #include <QLineEdit>
 
-class QMPLAY2SHAREDLIB_EXPORT LineEdit final : public QLineEdit
+class QAction;
+
+class QMPLAY2SHAREDLIB_EXPORT LineEdit : public QLineEdit
 {
     Q_OBJECT
 
 public:
     LineEdit(QWidget *parent = nullptr);
+    ~LineEdit();
 
+public slots:
     void clearText();
 
 signals:
     void clearButtonClicked();
+
+private slots:
+    void onTextChanged(const QString &text);
+
+private:
+    QAction *m_clearAct;
 };
diff --git a/src/qmplay2/Module.cpp b/src/qmplay2/Module.cpp
index 750d8677..04a0db78 100644
--- a/src/qmplay2/Module.cpp
+++ b/src/qmplay2/Module.cpp
@@ -35,7 +35,7 @@ void Module::videoDeintSave()
 void Module::setInstances(bool &restartPlaying)
 {
     QMutexLocker locker(&mutex);
-    for (ModuleCommon *mc : std::as_const(instances))
+    for (ModuleCommon *mc : instances)
         if (!mc->set())
             restartPlaying = true;
 }
diff --git a/src/qmplay2/Module.hpp b/src/qmplay2/Module.hpp
index f858aa96..84342929 100644
--- a/src/qmplay2/Module.hpp
+++ b/src/qmplay2/Module.hpp
@@ -127,7 +127,8 @@ template<typename T>
 void Module::setInstance()
 {
     QMutexLocker locker(&mutex);
-    for (ModuleCommon *mc : std::as_const(instances))
+    // Qt4: No std::as_const, iterate directly
+    foreach (ModuleCommon *mc, instances)
     {
         T *t = dynamic_cast<T *>(mc);
         if (t)
